/**********************************************************************\
*                                                                      *
*                  Copyright (c) Exeter University,		       *
*                  Department of Computer Science,                     *
*                 (aba@uk.ac.ex.dcs) Adam Back, 1994                   *
*                                                                      *
*  GNU GPL (General Public License) Applies.                           *
*                                                                      *
\**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <semaphor.h>
#include <channel.h>
#include "t_fork.h"
#include "t_amalloc.h"
#include "p4.h"
#include "p4_sys.h"

void* MainLocal;

int ForkCount = 0;
Semaphore ForkLock;
Channel ChildDone;

#define GSB_OFFSET 1

/*
void Interrupt( int gsb , void (*fn)() ){
  if ( gsb == (int)GSB() )
    fn();
  else {
    Process *p;
    p = ProcAlloc( fn, 0, 0 );
    p->wp[ GSB_OFFSET ] = gsb;          / * give process someone elses gsb * /
    ProcPar( p, 0 );
/ *    __asm{
      ld gsb;
      call stub;
      j skip;
    stub:
      ld fn;
      gcall;
    }
  skip:
    ;
* /
  }
}
*/

static void SubFork( Process *p, void (*child)(), int *id ) {
  *id = ++ForkCount;
  ChanOutInt( &ChildDone, ForkCount );
#ifdef SOCKET_SERVER
  if ( RegisterFork_with_SocketLib() == -1 )
    exit( 1 );
#endif
  child();
  return;
  p = p;			/* keep compiler quiet */
}

const char* t_bin(unsigned int x) {
  static char str[34];
  int i;
  strcpy(str,"00000000000000000000000000000000");
  for (i=0; i<32 && x != 0; i++) {
    str[i] = (x & (1u << 31)) > 0 ? '1' : '0';
    x <<= 1;
  }
  return str;
}

int ProcFork( void (*child)() ) {
  static int initialized = 0;
  int child_stack_size = *(int*)get_param(CONFIG_stack);
  int pid;
  char *wspace;
  Process* p;

  wspace = (char*) t_amalloc( child_stack_size, STACK_ALIGNMENT );
  if ( wspace == 0 ) return 0;
  p = (Process*) t_malloc( sizeof(Process) );
  if ( p == 0 ) return 0;
  ProcInit( p, SubFork, (void*)wspace, 
	    child_stack_size - sizeof(struct local_data), 
	    2, child, wspace + sizeof(struct local_data) );

				/* copy p4_local for child */

  memcpy( wspace, GetLocal(), sizeof(struct local_data) );

  if ( !initialized ) {
    SemInit( &ForkLock, 1 );
    ChanInit( &ChildDone );
    initialized = 1;
  }

  SemWait( &ForkLock );                  /* only start one child at a time */

  ProcRun( p );

  pid = ChanInInt( &ChildDone );         /* wait for child to get pid */
  SemSignal( &ForkLock );

  return pid;
}

int WaitFor( int *pids ){
  return ProcJoinList( (Process**) pids );
}

void *GetLocal( void ) {
  struct local_data* local;
  unsigned int WPtr;
  __asm {
    ldlp 0;
    st WPtr;
  }
  if ( t_in_malloc_arena( (void*)WPtr ) ) {
    local = (void*)(WPtr & STACK_MASK);
  } else {
    local = MainLocal;
  }
  return (void*)local;
}

int ForkId( void ) {
  unsigned int WPtr, id;
  __asm {
    ldlp 0;
    st WPtr;
  }
  if ( t_in_malloc_arena( (void*)WPtr ) ) {
    id = *(int*)((WPtr & STACK_MASK) | sizeof(struct local_data));
  } else {
    id = 0;
  }
  return id;
}
