/**********************************************************************\
*                                                                      *
*                  Copyright (c) Exeter University,		       *
*                  Department of Computer Science,                     *
*                 (aba@uk.ac.ex.dcs) Adam Back, 1994                   *
*                                                                      *
*  GNU GPL (General Public License) Applies.                           *
*                                                                      *
\**********************************************************************/
/*************************************************************************
*                                                                        *
*  Remote printing routines, allows printf to be used from remote        *
*  transputer nodes.                                                     *
*                                                                        *
*                                                                        *
*                                                                        *
*************************************************************************/
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <misc.h>
#include <channel.h>
#include <semaphor.h>
#include "t_cfs.h"

FILE *stdin;
FILE *stdout;
FILE *stderr;

void dbg_puts( const char * );

int vprintf(const char * format, __va_list arg) {
  int res;
  char string[10240];
  res = vsprintf( string, format, arg );
  dbg_puts( string );
  return res;
}

int _IMS_fprintf(FILE *f, const char *format, ... ) {
  va_list args;
  va_start( args, format );
  if (f == stderr) {
    vprintf(format, args);
  }
  return 0;
  f = f;
  format = format;		/* keep compiler quiet */
}

int _IMS_scanf( const char *format, ... ) {
  return 0;
  format = format;		/* keep compiler quiet */
}
int _IMS_fscanf( FILE *f, const char *format, ... ) {
  f = f; 
  format = format;		/* keep compiler quiet */
}

int fclose( FILE *f ) {
  f = f;			/* keep compiler quiet */
}

int printf( const char *format, ... ) {
  va_list args;
  va_start( args, format );
  return vprintf( format, args );
}

int _IMS_printf( const char *format, ... ) {
  va_list args;
  va_start( args, format );
  return vprintf( format, args );
}

char *fgets(char * s, int n, FILE * stream) {
  return 0;
  s = s;
  n = n;
  stream = stream;		/* keep compiler quiet */
}

FILE *fopen(const char * filename, const char * mode) {
  return 0;
  filename = filename;
  mode = mode;			/* keep compiler quiet */
}

size_t fread(void * ptr, size_t size, size_t nmemb, FILE * stream) {
  return 0;
  ptr = ptr;
  size = size;
  nmemb = nmemb;
  stream = stream;
}

FILE *freopen(const char * filename, const char * mode, FILE * stream) {
  return 0;
  filename = filename;
  mode = mode;
  stream = stream;		/* keep compiler quiet */
}

int fseek(FILE * stream, long int offset, int whence) {
  return 0;
  stream = stream;
  offset = offset;
  whence = whence;		/* keep compiler quiet */
}

long int ftell(FILE * stream) {
  stream = stream;		/* keep compiler quiet */
}

size_t fwrite(const void * ptr, size_t size, size_t nmemb, FILE * stream) {
  return 0;
  ptr = ptr;
  size = size;
  nmemb = nmemb;
  stream = stream;		/* keep compiler quiet */
}

int fputc(int c, FILE* str) {
  return 0;
  c = c;
  str = str;			/* keep compiler quiet */
}

char *gets(char * s) {
  return 0;
  s = s;			/* keep compiler quiet */
}

void perror(const char * s) {
  dbg_puts( s );
}

int fflush(FILE * stream) {
  return 0;
  stream = stream;
}

Semaphore lock = SEMAPHOREINIT(1);

void dbg_puts( const char * str ){
  Channel *out = get_param( CONFIG_printOut );
  SemWait( &lock );
  ChanOutInt( out, strlen( str ) + 1);
  ChanOut( out, (void*)str, strlen( str ) + 1);
  SemSignal( &lock );
}

/* need dummy symbol table entry for this for linking  */

void t_print_server_init( void ){
}
