/**********************************************************************\
*                                                                      *
*                  Copyright (c) Exeter University,		       *
*                  Department of Computer Science,                     *
*                 (aba@uk.ac.ex.dcs) Adam Back, 1994                   *
*                                                                      *
*  GNU GPL (General Public License) Applies.                           *
*                                                                      *
\**********************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <process.h>
#include <channel.h>
#include <misc.h>
#include "t_amalloc.h"
#include "t_cfs.h"
#include "t_pserver.h"

#define SERVER_STACK 1024

void print_server( Process *, Channel **, int );

FILE *outp;

#define BUF_SIZE 2048

int t_print_server_init( void ) {
  Process *d;
  int *wspace;
  Channel **in = get_param( CONFIG_printIn );
  int nprocs = *(int*) get_param( CONFIG_noProcs );
  char *filename;
  in[ nprocs ] = 0;
  filename = getenv("WHERE");
  if (filename) {
    outp = fopen( filename, "w" );
  } else {
    outp = stdout;
  }
  wspace = (int*) t_malloc( SERVER_STACK );
  if ( wspace == 0 ) exit(1);
  d = (Process*)t_malloc( sizeof(Process) );
  if ( d == 0 ) exit(1);
  ProcInit( d, print_server, wspace, SERVER_STACK, 2, in, nprocs );
  ProcRunHigh( d );
}

void print_server( Process *p, Channel **in, int nprocs ){
  int len, from, buf_size = BUF_SIZE;
  char *buf = (char*)t_malloc( BUF_SIZE );

  if (buf == 0) exit(1);
  while ( 1 ) {
    from = ProcAltList( in );
    if ( from >= 0 && from < nprocs ) {
      len = ChanInInt( in[ from ] );
      if ( len > buf_size ) {
	buf_size = (len / 1024 + 1) * 1024;
#ifdef DEBUG
	fprintf( outp, "<<< expanding printer server buffer to %d bytes >>>\n", 
		 buf_size );
#endif
	t_free( buf );
	buf = (char*)t_malloc( buf_size );
      }
      ChanIn( in[ from ], buf, len );
      buf[len - 1] = '\0';
      fprintf( outp, "%s", buf ); fflush( outp );
    }
  }
  p = p;			/* keep compiler quiet */
}

